exports.get_fields_list = async function(data, user_config=undefined)
{


	var lib_config = {}
	lib_config['table_fields_list'] = 'com_system_field_list' 
	lib_config['table_fields_config'] = 'required'


	var lib_config = await ext('com-api-system').log.valid_config(lib_config, user_config)

	if(lib_config['valid'] == false)
	{
		return lib_config
	}
	
	
		

	var db_config = {}
	db_config['table'] = lib_config['table_fields_config'] 
	db_config['value'] = {}
	db_config['value']['id'] = "1"
	db_config['alias'] = "config"


	var com_article_fields = await ext('com-api-database').sqlite.read(data,db_config)
	
	
	com_article_fields[0]['config'] = JSON.parse(com_article_fields[0]['config'])
	
	if(com_article_fields!="0")
	{
		var select_id_fileds_article = []
		for(var i in com_article_fields[0]['config']['fields_diplay'])
		{
			if(com_article_fields[0]['config']['fields_diplay'][i]['front']!=undefined)
			{
				select_id_fileds_article.push(i)
			}
		}
	}

	var db_config = {}
	db_config['table'] = lib_config['table_fields_list']
	db_config['value'] = {}

	db_config['value']['id'] = select_id_fileds_article.join('`')
	var result = await ext('com-api-database').sqlite.read(data,db_config)
	


	
	for(var i in result)
	{
		
		if(com_article_fields[0]['config']['fields_diplay'][result[i]['id']]!=undefined)
		{
			result[i]['display'] = com_article_fields[0]['config']['fields_diplay'][result[i]['id']]
		}

		if(result[i]['alias'] == "category")
		{
			result[i]['config'] = {}

			if(lib_config['fields_category_table']!=undefined && lib_config['category_table']!=undefined)
			{
				result[i]['config']['fields_table'] = lib_config['fields_category_table']
				result[i]['config']['table'] = lib_config['category_table']
				result[i]['config']['fields_category_edit_category'] = lib_config['fields_category_edit_category']

			}
			else
			{
				result[i]['config']['fields_table'] = 'com_'+data.user.request.component+'_category_fields'
				result[i]['config']['table'] = 'com_'+data.user.request.component+'_category_list'					
			}

			if(lib_config['type_edit'] == 'article')
			{
				result[i]['config']['type_select'] = "checkbox"
			}
			else
			{
				result[i]['config']['type_select'] = "radio"
			}

			if(lib_config['category_select']!=undefined)
			{
				result[i]['config']['select'] = lib_config['category_select']
			}
			
		}

		if(result[i]['rules']!=undefined && result[i]['rules']['unique']!=undefined)
		{
			result[i]['rules']['unique'] = lib_config['table_article']+':'+config['select_article']
		}
	

	}
	
	
	return result	
	
}


exports.views = async function(data,user_config)
{

		var lib_config = {}
		lib_config['fields'] = 'required'
		lib_config['article'] = 'required'

		lib_config['url'] = undefined
		//lib_config['article']['display'] = ''

		var lib_config = await ext('com-api-system').log.valid_config(lib_config, user_config)

		if(lib_config['valid'] == false)
		{
			return lib_config
		}


		var result = {}
		
		
		//var all_fields = JSON.parse(JSON.stringify(lib_config['fields']))
	
		for(var i in lib_config['fields'])
		{


			if(lib_config['article'][lib_config['fields'][i]['alias']]!=undefined && lib_config['article']['display']['fields'][lib_config['fields'][i]['id']]!=undefined)
			{


				if(lib_config['article']['display']['fields'][lib_config['fields'][i]['id']]['value']!=undefined ||  lib_config['article']['display']['fields'][lib_config['fields'][i]['id']]['title']!=undefined)
				{
					var config = lib_config['fields'][i]
					config['display'] = lib_config['article']['display']['fields'][lib_config['fields'][i]['id']]
					config['value'] = lib_config['article'][lib_config['fields'][i]['alias']]
					//config['fields'] = lib_config['fields']
					result[lib_config['fields'][i]['alias']] = await ext('com-api-system').field.view(data,config)

				}
			}
			
		}


	


		return result
}

exports.view = async function(data,user_config)
{


	var lib_config = {}

		lib_config['display'] = 'required'
		lib_config['url'] = ""



		var lib_config = await ext('com-api-system').log.valid_config(lib_config, user_config)

		if(lib_config['valid'] == false)
		{
			return lib_config
		}

		var result = {}

		if(lib_config['display']['value']!=undefined || lib_config['display']['title']!=undefined )
		{
			if(await ext("field-"+lib_config['type']) == undefined)
			{
				lib_config['type'] = 'system_other'
			}




			if(await ext("field-"+lib_config['type']).view!=undefined)
			{

				lib_config = await ext('lib-array').merge(await ext("field-"+lib_config['type']).view(data,lib_config),lib_config)

			}


			let type_field = lib_config['type'].split('_')

			var path_field_view = 'components/'+type_field[0]+'/admin/view/system/fields/'+type_field[1]+'/view.html'

			var field_value_view = lib_config['value'] 

			result['value'] = lib_config['value'] 

			if(await ext('com-api-filesbrowser').file.isset(path_field_view))
			{
				field_value_view = await ext('node-ejs').render(await ext('com-api-filesbrowser').file.read(path_field_view,{encoding:'utf8'}),{result: lib_config})
			}

			
			result['view'] = ""

			result['view'] += '<div id="field_'+lib_config['id']+'" class="field_view '+lib_config['type']+' '+lib_config['alias']+' '+lib_config['type']+'_'+lib_config['alias']+'">'

			if(lib_config['display']['title']!=undefined && lib_config['title']!=undefined)
			{
				result['view'] += '<div class="field_title">'+lib_config['title']+'</div>'
			}


			if(lib_config['display']['value']!=undefined)
			{
				
				
				result['view']  +='<div class="field_value">'
				if(lib_config['display']['link']!=undefined)
				{	

					if(lib_config['fields']!=undefined && Object.keys(lib_config['fields']).length!=0)
					{	
						lib_config['url'] = await ext('node-ejs').render(lib_config['url'], {fields_article: lib_config['fields']})
					}

					if(lib_config['url']!=undefined)
					{
						field_value_view = "<a href='"+lib_config['url']+"'>"+field_value_view+"</a>"
					}
					else
					{
						field_value_view = "<a>"+field_value_view+"</a>"
					}

					
				}

				if(lib_config['display']['wrap']!=undefined && lib_config['display']['wrap']!="none")
				{
					result['view']  +='<'+lib_config['display']['wrap']+'>'+field_value_view+'</'+lib_config['display']['wrap']+'>'
				}
				else
				{
					result['view']  += field_value_view
				}

				result['view']  +='</div>'
				
			}
	
			result['view']  +='</div>'
		}

	
		return result
}


exports.form = async function(data,user_config=undefined)
{
	var lib_config = {}
		lib_config['fields_list'] = 'required'
		lib_config['fields_value'] = undefined

		var lib_config = await ext('com-api-system').log.valid_config(lib_config, user_config)

		if(lib_config['valid'] == false)
		{
			return lib_config
		}
		

		

		var result = {}	
		result['fields'] = {}

		data.load.view.js.component['/components/system/admin/view/start/system/function.js'] = '/components/system/admin/view/start/system/function.js'
		data.load.view.ready_js.push('com_system.form_valid_ajax()')


		lib_config['fields_list'] = await ext('lib-array').sort_arr(lib_config['fields_list'],'od','>')


		var select_alias_fields_article = []


		
		for(var i_s in lib_config['fields_list'])
		{

			result['fields'][i_s] = lib_config['fields_list'][i_s]
						
			/*

			if(lib_config['fields_value']!=undefined && Object.keys(value_field).length!=0)
			{

				if(com_system_fields_list[i_s]['alias'].indexOf('[')!=-1)
				{

					
					var alias = await ext('lib-array').sub_parser_alias_data(com_system_fields_list[i_s]['alias'], value_field[com_system_fields_list[i_s]['alias']])
					
					if(typeof alias == 'object')
					{

						var value = {}
						value[Object.keys(alias)[0]] = JSON.parse(value_field[Object.keys(alias)[0]])					
						field['value'] = await ext('lib-array').get_val_str_key(com_system_fields_list[i_s]['alias'], value)
						
					}
				}
				else
				{
						field['value'] = value_field[com_system_fields_list[i_s]['alias']]
				}
				
			}
			*/

			/*
			if(result_valid_form!=undefined && result_valid_form['error']!=undefined)
			{
				if(result_valid_form['error'][field['alias']]!=undefined)
				{
					field['valid_result'] = "error"
				}
				else
				{
					field['valid_result'] = "success"
				}
				
			}

			*/


			var config_field = {}
			config_field['field'] = result['fields'][i_s]

			result['fields'][i_s]['view'] = await this.edit(data,config_field)

			console.log(result['fields'][i_s]['view'])
			
		}

	

		/*
		
			 
		result['fields'] = {}	

		if(typeof article_fields == "string")
		{
			var db_config = {}
			db_config['table'] = article_fields
			db_config['value'] = {}
			db_config['value']['id'] = "1"
			db_config['select_alias'] = "config"
			var com_article_fields = await ext('com-api-database').sqlite.read(data,db_config)

				
			if(com_article_fields!="0")
			{
				com_article_fields[0]['config'] = JSON.parse(com_article_fields[0]['config'])

				var select_id_fileds_article = []
				for(var i in com_article_fields[0]['config']['fields_diplay'])
				{
					if(com_article_fields[0]['config']['fields_diplay'][i]['front']!=undefined)
					{
						select_id_fileds_article.push(i)
					}
				}
			}
		
			var db_config = {}
			db_config['table'] = 'com_system_fields_list'
			db_config['value'] = {}

			db_config['value']['id'] = select_id_fileds_article.join('`')
			var com_system_fields_list = await ext('com-api-database').sqlite.read(data,db_config)			
			



		}

		if(typeof article_fields == "object")
		{
			var com_system_fields_list = article_fields
			
			
		}
		


		for(var i in com_system_fields_list)
		{
			for(var a in com_article_fields)
			{
				if(com_article_fields[a]['id_field'] == com_system_fields_list[i]['id'])
				{
					com_system_fields_list[i]['od'] = com_article_fields[a]['od']
				}
			}
		}



		
		if(com_system_fields_list[Object.keys(com_system_fields_list)[0]]['od']!=undefined)
		{
			com_system_fields_list = await ext('lib-array').sort_arr(com_system_fields_list,'od','>')
		}


	
		
		var select_alias_fields_article = []


		
		for(var i_s in com_system_fields_list)
		{
			var field = com_system_fields_list[i_s]
			
		

			field['fields'] = value_field
		
			select_alias_fields_article[i_s] = com_system_fields_list[i_s]['alias']
			

			if(value_field!=undefined && Object.keys(value_field).length!=0)
			{

				if(com_system_fields_list[i_s]['alias'].indexOf('[')!=-1)
				{

					
					var alias = await ext('lib-array').sub_parser_alias_data(com_system_fields_list[i_s]['alias'], value_field[com_system_fields_list[i_s]['alias']])
					
					if(typeof alias == 'object')
					{

						var value = {}
						value[Object.keys(alias)[0]] = JSON.parse(value_field[Object.keys(alias)[0]])					
						field['value'] = await ext('lib-array').get_val_str_key(com_system_fields_list[i_s]['alias'], value)
						
					}
				}
				else
				{
						field['value'] = value_field[com_system_fields_list[i_s]['alias']]
				}
				
			}


			if(result_valid_form!=undefined && result_valid_form['error']!=undefined)
			{
				if(result_valid_form['error'][field['alias']]!=undefined)
				{
					field['valid_result'] = "error"
				}
				else
				{
					field['valid_result'] = "success"
				}
				
			}
			

			result['fields'][i_s] = field



			result['fields'][i_s]['view'] = await this.edit(data,field)
		}

		

	
		
		return result
		*/
}


exports.form_valid = async function(data,config)
{
	var result = {}
		result['error'] = []
		result['fields'] = {}



		if(typeof config['fields'] == "string")
		{
			var db_config = {}
			db_config['table'] = config['fields']
			db_config['value'] = {}
			db_config['value']['id'] = "1"
			db_config['select_alias'] = "config"
			var com_article_fields = await ext('com-api-database').sqlite.read(data,db_config)

			if(com_article_fields!="0")
			{
				var select_id_fileds_article = []
				for(var i in com_article_fields[0]['config']['fields_diplay'])
				{
					if(com_article_fields[0]['config']['fields_diplay'][i]['front']!=undefined)
					{
						select_id_fileds_article.push(i)
					}
				}
			}

			var db_config = {}
			db_config['table'] = 'com_system_field_list'
			db_config['value'] = {}
			db_config['value']['id'] = select_id_fileds_article.join('`')

			
			var com_system_fields_list = await ext('com-api-database').sqlite.read(data,db_config, true)
		}
		
		if(typeof config['fields'] == "object")
		{
			var com_system_fields_list = config['fields']
		}
		

		for(var i_s in com_system_fields_list)
		{
			com_system_fields_list[i_s]['value'] = await ext('lib-array').get_val_str_key(com_system_fields_list[i_s]['alias'], config['post_data'])
			

		}


		for(var i_s in com_system_fields_list)
		{

			var type_field = com_system_fields_list[i_s]['type'].split('_')
			
			if(await ext('com-api-filesbrowser').file.isset('components/'+type_field[0]+'/admin/functions/system/fields/'+type_field[1]+'_field.js'))
			{		

				var field_import = await ext('field-'+com_system_fields_list[i_s]['type'])
				if(field_import.edit_save!=undefined)
				{
					com_system_fields_list[i_s]['value'] = await field_import.edit_save(data,com_system_fields_list[i_s]['value'])		
				}
			
				
				var config_filed_valid = {}
				config_filed_valid['fields'] = com_system_fields_list
				config_filed_valid['field'] = com_system_fields_list[i_s]
				config_filed_valid['field']['value'] = com_system_fields_list[i_s]['value']
				var r = await this.valid(data, config_filed_valid)


				if(r!="0")
				{
					result['error'][com_system_fields_list[i_s]['alias']] = r
				}	


			}

	

			if(com_system_fields_list[i_s]['alias'].indexOf('[')!=-1)
			{
				result['fields'] = await ext('lib-array').merge(result['fields'], await ext('lib-array').sub_parser_alias_data(com_system_fields_list[i_s]['alias'], com_system_fields_list[i_s]['value'])) 
			}
			else
			{

				if(com_system_fields_list[i_s]['value'] == "")
				{
					result['fields'][com_system_fields_list[i_s]['alias']] = undefined
				}
				else
				{
					result['fields'][com_system_fields_list[i_s]['alias']] = com_system_fields_list[i_s]['value']
				}
				
			}	

					
		}


		for(var i in result['fields'])
		{
			if(typeof result['fields'][i] == 'object')
			{

				result['fields'][i] = JSON.stringify(result['fields'][i])
			}
		}

		if(Object.keys(result['error']).length == 0)
		{
			result['error'] = "0"
		}
		return result
}


exports.valid = async function(data,config)
{
	var result_error = []

		if(config['field']['rules']!="0" && config['field']['rules']!=undefined)
		{

			if(config['field']['rules']['required']!=undefined)
			{
				if(config['field']['value']=="")
				{
					result_error.push('Поле "'+config['field']['title']+'" являеться обязательным для заполнения')
				}
			}


			if(config['field']['rules']['unique']!=undefined)
			{
				

				config['field']['rules']['unique'] = config['field']['rules']['unique'].split(':')
				
				var db_config = {}
				db_config['table'] = config['field']['rules']['unique'][0]
				db_config['alias'] = "id"
				
			
				

				if(typeof config['field']['value'] == "object")
				{
					db_config['value_like'] = {}
					db_config['value_like'][config['field']['alias']] = new RegExp( '"value":"'+config['field']['value']['value']+'"', 'g');

					var value_text = config['field']['value']['value']
				}
				else
				{
					db_config['value'] = {}
					db_config['value'][config['field']['alias']] = config['field']['value']
					var value_text = config['field']['value']
				}
				
				
				if(config['field']['rules']['unique'][1]!=undefined)
				{
					db_config['ignore'] = {}
					db_config['ignore']['id'] = config['field']['rules']['unique'][1]
				}
				var r = await ext('com-api-database').sqlite.read(data,db_config)
				
				if(r!=undefined)
				{
					result_error.push('Материал со значением "'+value_text+'" поля "'+config['field']['title']+'" уже существует')
				}
				
				
			}



			if(config['field']['rules']['mail']!=undefined)
			{	
				const re = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
				if(re.test(String(config['field']['value']).toLowerCase()) == false)
				{
					result_error.push('Значение введеное в поле "'+config['field']['title']+'" не являеться E-Mail')
				}
				
			}
		}

		if(result_error.length == 0)
		{
			return "0"
		}
		else
		{
			return result_error
		}
}


exports.edit = async function(data,user_config)
{
	var lib_config = {}
		lib_config['field'] = {}
		lib_config['field']['title'] = 'required'
		lib_config['field']['type'] = "required"
		lib_config['field']['alias'] = "required"
		lib_config['field']['display'] = {}
		lib_config['field']['display']['title'] = "show"
		lib_config['field']['display']['hint'] = "show"
		lib_config['field']['display']['value'] = "show"

		var lib_config = await ext('com-api-system').log.valid_config(lib_config, user_config)

		if(lib_config['valid'] == false)
		{
			return lib_config
		}
		


		var result = ""
		if(await ext('field-'+lib_config['field']['type'])!=undefined)
		{
			var field_edit_fun = await ext('field-'+lib_config['field']['type']).edit(data,lib_config['field'])
			lib_config['field'] = await ext('lib-array').merge(lib_config['field'], field_edit_fun)



		}
		
		/*

		if(field['hight'] == undefined)
		{
			var view_field = ""

			if(await ext('field-'+field['type'])!=undefined)
			{

				
					var result_field = await ext('field-'+field['type']).edit(data,field)

					field = await ext('lib-array').merge(field, result_field)


					if(result_field['value']!=undefined)
					{
						field['value'] = result_field['value']
					}

						

			

					if(field['name'] == undefined)
					{
						field['name'] = field['alias']
					}

					if(field['config'] == undefined)
					{
						field['config'] = {}
					}

					if(field['config']['display'] == undefined)
					{
						field['config']['display'] = {}
					}

					if(field['config']['display']['title'] == undefined)
					{
						field['config']['display']['title'] = "show"
					}


					if(field['config']['display']['hint'] == undefined)
					{
						field['config']['display']['hint'] = "show"
					}
					if(field['config']['display']['value'] == undefined)
					{
						field['config']['display']['value'] = "show"
					}

					

					if(field['valid_result'] == undefined)
					{
						field['valid_result'] = ""
					}
					else
					{
						field['valid_result'] = "valid_result_"+field['valid_result']
					}

					var type_field = field['type'].split('_')

					var path_field_view = 'components/'+type_field[0]+'/admin/view/system/fields/'+type_field[1]+'/edit.html'

					if(await ext('com-api-filesbrowser').file.isset(path_field_view)!=false)
					{
						
						view_field = await ext('node-ejs').render(await ext('com-api-filesbrowser').file.read(path_field_view, 'utf8'), {result:field});
					}
					else
					{
						
						if(field['view']!=undefined)
						{


							field['view'] = await ext('node-ejs').render(field['view'], {result: field});
							view_field = await ext('node-ejs').render(await ext('com-api-filesbrowser').file.read('components/system/admin/view/system/fields/other/edit.html', 'utf8'), {result: field});
						}

					}

					if(view_field!="")
					{
						


						result = '<div class="'+field['valid_result']+' field_edit '+field['type']+' '+field['alias']+' '+field['type']+'_'+field['alias']+'" id="field_edit_'+field['type']+'_'+field['alias']+'" rules=\''+JSON.stringify(field['rules'])+'\'>'+view_field+'</div>'	

					}

				}
				else
				{
					await ext('com-api-system').log.write(await ext('node-callsites')()[0], "no field "+'field-'+field['type'])	
				}
		}
		*/
		return result
	
}


