exports.meta_title = ""
exports.meta_keywords = ""
exports.meta_description = ""


exports.component = async function(data,config_component=undefined)
{

	if(data.user.request.type == 'http')
	{
		var config = {}
		config['component'] = data.user.request.component
		config['type_page'] = data.user.request.type_page
		config['function'] = data.user.request.function

		if(config_component!=undefined)
		{
			config = await ext('lib-array').merge(config,config_component)
		}

		var load_component = await ext('com-fun-'+config['component']+'-'+config['type_page']+'-'+config['function'])

		if(load_component !=undefined)
		{
			var com_data = await ext('com-fun-'+config['component']+'-'+config['type_page']+'-'+config['function']).com.start(data,config)

			var config_template = {}
			config_template.type = "component"
			config_template.template = "default"


			config_template.type_page = data.user.request.type_page
			config_template.component = data.user.request.component
			config_template.function = data.user.request.function


			config_template = await ext('lib-array').merge(config_template, com_data)

		

			
			//config_template.prefix_template = "full_view"
			
			data.server.response_status = 200
		}
		else
		{
			var com_data = await ext('com-fun-system-'+data.user.request.type_page+'-error').com.start(404)

			var config_template = {}
			config_template.type = "component"
			config_template.template = "default"
			config_template.type_page = data.user.request.type_page
			config_template.component = "system"
			config_template.function = "error"	
		}

		
		return await this.view(data,config_template,com_data)
	}

	if(data.user.request.type == 'ajax')
	{
		///ajax/component/admin/system/fields/fields/field/uploadfile/15?com=upload


		var ext_ajax = await ext('com-ajax-'+data.user.request.component+'-'+data.user.request.type_page+'-'+data.user.request.function) 

		if(ext_ajax!=undefined)
		{
			if(ext_ajax[await ext('lib-request').url_segment(5, data.server.req.url)]!=undefined)
			{
				if(ext_ajax[await ext('lib-request').url_segment(5, data.server.req.url)][await ext('lib-request').url_segment(6, data.server.req.url)]!=undefined)
				{
					data.server.response_status = 200
					return ext_ajax[await ext('lib-request').url_segment(5, data.server.req.url)][await ext('lib-request').url_segment(6, data.server.req.url)](data)
				}
				else
				{
					await ext('com-api-system').log.write(await ext('node-callsites')()[0], 'com-ajax-'+data.user.request.component+'-'+data.user.request.type_page+'-'+data.user.request.function+'.'+await ext('lib-request').url_segment(5, data.server.req.url)+' not function "'+await ext('lib-request').url_segment(6, data.server.req.url)+"'")
					var r  = {}
					r['error'] = "404"
					data.server.response_status = 404
					return JSON.stringify(r)
				}
				
			}
			else
			{
				await ext('com-api-system').log.write(await ext('node-callsites')()[0], 'com-ajax-'+data.user.request.component+'-'+data.user.request.type_page+'-'+data.user.request.function+' is no module in the "'+await ext('lib-request').url_segment(5, data.server.req.url)+"'")
				var r  = {}
				r['error'] = "404"
				data.server.response_status = 404
				return JSON.stringify(r)

			}
		}
		else
		{


			await ext('com-api-system').log.write(await ext('node-callsites')()[0], 'There is no expansion '+'com-ajax-'+data.user.request.component+'-'+data.user.request.type_page+'-'+data.user.request.function)
			var r  = {}
			r['error'] = "404"
			data.server.response_status = 404
			return JSON.stringify(r)

		}

		
	}

	if(data.user.request.type == 'ws')
	{

		try
		{
			///ws/component/admin/system/start/form/field_valid
			data.server.response_status = 200
			var r = await ext('com-ws-'+data.user.request.component+'-'+data.user.request.type_page+'-'+data.user.request.function)[await ext('lib-request').url_segment(5, data.server.req.url)][await ext('lib-request').url_segment(6, data.server.req.url)](data)				
			return r
		}
		catch(e)
		{
			console.log(e)
			var r  = {}
			r['error'] = "404"
			data.server.response_status = 404
			return JSON.stringify(r)
			
		}
	}

	if(data.user.request.type == 'api')
	{
		try
		{
			data.server.response_status = 200
			
			var r = await ext('com-api-'+data.user.request.component)[data.user.request.function][data.user.request.command](data)			
			return r
		}
		catch(e)
		{
			console.log(e)
			var r  = {}
			r['error'] = "404"
			data.server.response_status = 404
			return JSON.stringify(r)
			
		}
	}
}

exports.plugins = async function(data,config=undefined)
{
	this.view_plugins = []
	var read_dir_pl = await ext('com-api-filesbrowser').dir.read('plugins')
	var select_plugins = {}
	for(var pl in read_dir_pl)
	{

		var info_pl = await ext('com-api-filesbrowser').file.read('plugins/'+read_dir_pl[pl]+'/package.json')
		select_plugins[pl] = info_pl
		select_plugins[pl]['name'] = read_dir_pl[pl]
	}

	select_plugins = await ext('lib-array').sort_arr(select_plugins, "order", ">")
	
	for(var pl in select_plugins)
	{

		await this.plugin(data,select_plugins[pl])

	}

	this.fun_plugins = {}
}

exports.plugin = async function(data,config=undefined)
{
	if(data.user.request.type == 'http')
	{
		var data_plugin = await ext('pl-front-'+config['name']).pl.start(data)

		let config_template = {}
		config_template.type = "plugin"
		config_template.plugin_name = config['name']
		config_template.template = "default"
		data.load.view.plugins[config['name']] = await this.view(data,config_template, data_plugin)
	}

	if(data.user.request.type == 'ws')
	{

		try
		{
			///ws/component/admin/system/start/form/field_valid
			data.server.response_status = 200
			var r = await ext('pl-ws-'+data.user.request.component+'-'+data.user.request.type_page+'-'+data.user.request.function)[await ext('lib-request').url_segment(4, data.server.req.url)][await ext('lib-request').url_segment(5, data.server.req.url)](data)				
			return r
		}
		catch(e)
		{
			console.log(e)
			var r  = {}
			r['error'] = "404"
			data.server.response_status = 404
			return JSON.stringify(r)
			
		}
	}
}

exports.modules = async function(data, config=undefined)
{
	if(await data.user.request.type_page != "admin")
	{
		let db_conf = {}
		db_conf['table'] = "com_system_setting"
		db_conf['value'] = {}
		db_conf['value']['id'] = "1"
		var r = await ext('com-api-database').sqlite.read(data,db_conf)

		var path_index_template = await this.get_index_file(data,'components/system/front/view/main/template/'+r[0]['template'])
	}
	else
	{
		var path_index_template = await this.get_index_file(data,'components/system/admin/view/main/template/default')
	}


	
	var read_index_template = await ext('com-api-filesbrowser').file.read(path_index_template,{encoding:'utf8'})
	var module_positions = await read_index_template.match(/<%-module.position.*?%>/g);	
	var module_positions_promise = []
	
	
	for(let i in module_positions)
	{
		let name_position = await module_positions[i].replace("<%-module.position.","");
		name_position = await name_position.replace("%>","")
		
		module_positions_promise[i] = new Promise((resolve, reject) => {
			let conf = {}
			conf['position'] = name_position	

			resolve(this.module_positions(data,conf))
		});
	}


	await Promise.all(module_positions_promise).then(data_p => {
		for(var i in data_p)
		{

			data.load.view.modules.position[data_p[i].name_position] = data_p[i].view

		}
		
	});
}

exports.module_positions = async function(data,config=undefined)
{
	let result = {}
	result.name_position = config.position
	
	

	result.view = '<div class="mod_position position_'+config.position+'">'
	if(await data.user.request.type_page != "admin")
	{

		var db_conf = {}
		db_conf['table'] = "com_modules_module_list"
		db_conf['value_like'] = {}
		db_conf['value_like']['display_pages'] = '%"all"%';
		db_conf['value_like']['position'] = '%"'+config.position+'"%';
		db_conf['value_like']['display'] = '%"active":"on"%';
		var select_modules = await ext('com-api-database').sqlite.read(data,db_conf)

		var url = await ext('lib-request').clear_url(data.server.req.url)

		var db_conf = {}
		db_conf['table'] = "com_modules_module_list"
		db_conf['value_like'] = {}
		db_conf['value_like']['display_pages'] = '%"'+url+'"%';
		db_conf['value_like']['position'] ='%"'+config.position+'"%';
		db_conf['value_like']['display'] ='%"active":"on"%';
		
		var select_modules_page = await ext('com-api-database').sqlite.read(data,db_conf)


		
		select_modules = await ext('lib-array').merge(select_modules, select_modules_page)

		
		if(select_modules!=undefined)
		{
			select_modules = await ext('lib-array').sort_arr(select_modules, "od", ">")
		}
		
		
	}
	else
	{

		var admin_module = await ext('com-api-filesbrowser').dir.read('modules')
		var select_modules = {}
		for(var i in admin_module)
		{
			if(admin_module[i].indexOf('admin_')!=-1)
			{
				let package_info = await ext('com-api-filesbrowser').file.read('modules/'+admin_module[i]+"/package.json", "utf-8")

				if(package_info['position'].includes(result.name_position))
				{							
					select_modules[i] = {}
					select_modules[i]['type'] = admin_module[i]
					select_modules[i]['display'] = '{"fields":{"full_view":{"2":{"wrap":"none"},"3":{"value":"on","wrap":"none"}}},"full_view":{"template":"default"}}'
					
					select_modules[i]['display_pages'] =  'all'
				}
			}
		}

	}


	if(select_modules!=undefined)
	{

		for(let i in select_modules)
		{
			select_modules[i]['display'] = JSON.parse(select_modules[i]['display'])


			result.view += await this.modul(data,select_modules[i])
		}
		
	}

	result.view += '</div>'
	return result
}

exports.modul = async function(data,config=undefined)
{
	var result = ""
	var data_module = {}
	let config_template = {}
	config_template.type = "module"
	config_template.module_type = config['type']
	config_template.module_id = config['id']
	config_template.template = config['display']['full_view']['template']



	
	var data_module = {}
	var data_module = await ext('lib-array').merge(data_module, await ext('mod-front-'+config['type']).mod.start(data,config))

	if(data_module!=undefined && data_module['fields']!=undefined)
	{
		
		var fields_module = {}
		for(var i in data_module['fields'])
		{
			fields_module[i] = {}
			fields_module[i]['title'] = ""
			fields_module[i]['alias'] = i
			fields_module[i]['type'] = 'system_'+i
			fields_module[i]['id'] = i
		}

		
		config = await ext('lib-array').merge(config,data_module['fields'])
		
		var config_view_fields = {}
		config_view_fields['fields'] = fields_module
		config_view_fields['article'] = data_module['fields']
		config_view_fields['article']['display']['fields'] = config_view_fields['article']['display']['fields']['full_view']
		var fields = await ext('com-api-system').field.views(data,config_view_fields)

		data_module['fields'] = {}

		for(var i in fields)
		{
			data_module['fields'][fields[i]['alias']] = fields[i]['view']
		}

		

	}
	
	



	return await this.view(data,config_template, data_module)
}

exports.view = async function(data,load_template, data_ext)
{

	var path_index = undefined

	if(load_template!=undefined && load_template.type == "component")
	{

		if(load_template.prefix_template!=undefined)
		{
			load_template.prefix_template += '/'
		}
		else
		{
			load_template.prefix_template = ""
		}

		

		var class_css_prefix = load_template.prefix_template.slice(0, -1).replaceAll('/',"_")
		if(class_css_prefix!="")
		{
			class_css_prefix = 'prefix_'+class_css_prefix
		}

		

		path_index = await this.get_index_file(data,'/components/'+load_template.component+'/'+load_template.type_page+'/view/'+load_template.function+'/template/'+load_template.prefix_template+load_template.template)
		

		await this.css_js(data,'components/'+load_template.component+'/'+load_template.type_page+'/view/'+load_template.function+'/template/'+load_template.prefix_template+load_template.template, "component")
		
		var result = '<div id="component_'+load_template.component+'_'+load_template.function+'" class="component '+class_css_prefix+' '+load_template.component+'_'+load_template.function+' template_'+load_template['template']+'">'
		
		result += await ext('node-ejs').render(await ext('com-api-filesbrowser').file.read(path_index,{encoding:'utf8'}),{result: data_ext});
		result+='</div>'

		return result

	}

	if(load_template!=undefined && load_template.type == "module")
	{

		path_index = await this.get_index_file(data,'/modules/'+load_template['module_type']+'/front/view/template/'+load_template.template)
		await this.css_js(data,'modules/'+load_template['module_type']+'/front/view/template/'+load_template.template, "module")
		var result = '<div id="module_'+load_template['module_id']+'" class="module type_module_'+load_template['module_type']+' template_'+load_template['template']+'">'			
		if(data_ext.field == undefined)
		{
			data_ext.field = {}
		}

		result += await ext('node-ejs').render(await ext('com-api-filesbrowser').file.read(path_index,{encoding:'utf8'}), {result: data_ext});
		result+='</div>'
		return result
	}

	if(load_template!=undefined && load_template.type == "plugin")
	{
		
		path_index = await this.get_index_file(data,'/plugins/'+load_template['plugin_name']+'/front/view/template/'+load_template.template)
		await this.css_js(data,'plugins/'+load_template['plugin_name']+'/front/view/template/'+load_template.template, "plugin")
		var result = '<div id="plugin_'+load_template['plugin_name']+'" class="plugin type_plugin_'+load_template['plugin_name']+' template_'+load_template['template']+'">'			
		result += await ext('node-ejs').render(await ext('com-api-filesbrowser').file.read(path_index,{encoding:'utf8'}), {result:data_ext});
		result+='</div>'
		return result
	}

	if(load_template==undefined)
	{

		var path_template = 'components/system/front/view/main/template/default'

		if(await data.user.request.type_page != "admin")
		{
			let db_conf = {}
			db_conf['table'] = "com_system_setting"
			db_conf['value'] = {}
			db_conf['value']['id'] = "1"
			let r = await ext('com-api-database').sqlite.read(data,db_conf)
			path_template = 'components/system/front/view/main/template/'+r[0]['template']				
		}
		else
		{
			path_template = 'components/system/admin/view/main/template/default'
		}

		path_index = await this.get_index_file(data,path_template)
		await this.css_js(data,path_template, "main")
		
		let view_main ="<!DOCTYPE html>\n"
		view_main += '<head>\n'
		view_main += '<title>'+this.meta_title+'</title>\n'
		view_main += '<meta  http-equiv="Content-Type" content="text/html; charset="utf-8">\n'
		view_main += '<meta name="keywords" content="'+this.meta_keywords+'">\n'
		view_main += '<meta name="description" content="'+this.meta_description+'">\n'
		view_main += '<link rel="icon" type="image/x-icon" href="/'+path_template+'/favicon.ico">\n'
		

		
		if(data.load.view.css['main']!=undefined)
		{

			for(let i in data.load.view.css['main'])
			{
				view_main += '<link rel="stylesheet" type="text/css" href="'+data.load.view.css['main'][i]+'" />\n'
			}
		}

		if(data.load.view.css['plugin']!=undefined)
		{
			for(let i in data.load.view.css['plugin'])
			{
				view_main += '<link rel="stylesheet" type="text/css" href="'+data.load.view.css['plugin'][i]+'" />\n'
			}
		}

		if(data.load.view.css['component']!=undefined)
		{
			for(let i in data.load.view.css['component'])
			{
				view_main += '<link rel="stylesheet" type="text/css" href="'+data.load.view.css['component'][i]+'" />\n'
			}
		}


		if(data.load.view.css['module']!=undefined)
		{
			for(let i in data.load.view.css['module'])
			{
				view_main += '<link rel="stylesheet" type="text/css" href="'+data.load.view.css['module'][i]+'" />\n'
			}
		}

		


		for(let i in data.load.view.js['plugin'])
		{
			view_main += '<script type="text/javascript" src="'+data.load.view.js['plugin'][i]+'"></script>\n'
		}

		for(let i in data.load.view.js['main'])
		{
			view_main += '<script type="text/javascript" src="'+data.load.view.js['main'][i]+'"></script>\n'
		}

		for(let i in data.load.view.js['component'])
		{
			view_main += '<script type="text/javascript" src="'+data.load.view.js['component'][i]+'"></script>\n'
		}

		for(let i in data.load.view.js['module'])
		{
			view_main += '<script type="text/javascript" src="'+data.load.view.js['module'][i]+'"></script>\n'
		}

		



		view_main += '</head>\n<body >\n'
		

		view_main += '<script>\n$(document).ready(function(){\n'

		for(var i in data.load.view.ready_js)
		{

			view_main += data.load.view.ready_js[i]+"\n"
		}
		view_main += '})\n</script>\n'
	
		
		for(var i in data.load.view.plugins)
		{

			view_main += data.load.view.plugins[i]+"\n"
		}
		
		var data_ext = {}
		data_ext.module = data.load.view.modules
		data_ext.component = data.load.view.component
		

		view_main += await ext('node-ejs').render(await ext('com-api-filesbrowser').file.read(path_index,{encoding:'utf8'}), data_ext);
		view_main += '\n</body>\n</html>\n'


		return view_main
	}

	return this
}

exports.get_index_file = async function(data,path)
{
	if(await ext('com-api-filesbrowser').file.isset(path+"/"+data.user.user_agent.device.type+"_index.html"))
	{
		return path+"/"+data.user.user_agent.device.type+"_index.html"
	}
	else
	{
		return path+"/index.html"
	}
}

exports.css_js = async function(data,path, type=undefined)
{
	var issset_config = await ext('com-api-filesbrowser').file.isset(path+"/config.json")
		if(issset_config!=false)
		{
			var config_temp = await ext('com-api-filesbrowser').file.read(path+"/config.json")
		}
		
		if(config_temp!=undefined)
		{
			if(config_temp['css']!=undefined)
			{
				var css_file = []

				for(var i in config_temp['css'])
				{
					if(config_temp['css'][i].indexOf('http')==-1)
					{
						if(config_temp['css'][i].indexOf('mobile_')==-1)
						{

							var path_file = config_temp['css'][i].substr(0, config_temp['css'][i].lastIndexOf('/')+1)
							var mime = await ext('com-api-filesbrowser').file.mime(path+"/css/"+config_temp['css'][i])

							if(mime!=undefined && mime['mime']!=false)
							{
							

								if(await ext('com-api-filesbrowser').file.isset(path+"/css/"+path_file+data.user.user_agent.device.type+"_"+mime['name']))
								{
									css_file.push("/"+path+"/css/"+path_file+data.user.user_agent.device.type+"_"+mime['name'])
								}
								else
								{
									css_file.push("/"+path+"/css/"+path_file+mime['name'])
								}
							}
						}
					}
					else
					{

						css_file.push(config_temp['css'][i])
					}
				}



				
				if(css_file.length !=0)
				{
					if(data.load.view.css[type] == undefined)
					{
						data.load.view.css[type] = {}
					}
					
					for(var i in css_file)
					{
						
						data.load.view.css[type][css_file[i]] =css_file[i]

						
					}

					
				}
			}

			if(config_temp['js']!=undefined)
			{


				var js_file = []

				for(var i in config_temp['js'])
				{
					if(config_temp['js'][i].indexOf('http')==-1)
					{
						if(config_temp['js'][i].indexOf('mobile_')==-1)
						{

							var path_file = config_temp['js'][i].substr(0, config_temp['js'][i].lastIndexOf('/')+1)
							var mime = await ext('com-api-filesbrowser').file.mime(path+"/js/"+config_temp['js'][i])
						
							if(mime!=undefined && mime['mime']!=false)
							{
							

								if(await ext('com-api-filesbrowser').file.isset(path+"/js/"+path_file+data.user.user_agent.device.type+"_"+mime['name']))
								{
									js_file.push("/"+path+"/js/"+path_file+data.user.user_agent.device.type+"_"+mime['name'])
								}
								else
								{
									js_file.push("/"+path+"/js/"+path_file+mime['name'])
								}
							}
						}
					}
					else
					{

						js_file.push(config_temp['js'][i])
					}
				}



				
				if(js_file.length !=0)
				{
					if(data.load.view.js[type] == undefined)
					{
						data.load.view.js[type] = {}
					}
					
					for(var i in js_file)
					{
						
						data.load.view.js[type][js_file[i]] =js_file[i]

						
					}

					
				}
			}
	


		}
		

		
}